<template>
  <div class="column" :class="{ completed: column.state == 'complete', error: column.state == 'error', locked: !column.state == 'locked' && column.isEditable, editing: column.state == 'editing'}" @drop.prevent="onDrop($event, column.step)" @dragenter.prevent @dragleave="onDragleave($event)" @dragover.prevent="onDragover($event)" :data-step="column.step">
    <div class="column-header">
      <div class="column-header-text">
        <h2>{{ column.title }}</h2>
        <CheckCircleIcon v-if="column.state == 'complete'"></CheckCircleIcon>
        <AlertIcon v-if="column.state == 'error'"></AlertIcon>
        <LockIcon v-if="column.state == 'locked' && column.isEditable"></LockIcon>
        <ClockIcon v-if="column.state == 'editing'"></ClockIcon>
      </div>
      <div v-if="column.isEditable" class="icon column-header-icon" @click="toggleDropdown">
        <DotsVerticalIcon></DotsVerticalIcon>
      </div>
      <div v-if="column.step === 0" class="icon column-header-icon">
        <RestartIcon></RestartIcon>
      </div>
      <Dropdown v-show="dropdownIsActive" :column="column" @check-result="checkResult(column)"></Dropdown>
    </div>
    <div class="column-content">
      <div class="locked-overlay" v-if="column.state == 'locked' && column.isEditable">
      </div>
      <div v-if="column.title == 'Kettenregeln'">
        <UnitRule v-if="column.unitRulesWithSets" v-for="rule in column.unitRulesWithSets" :key="rule.sym" :rule="rule" :is-wrong="isWrongUnitRule(rule)"></UnitRule>
        <hr v-if="column.unitRulesWithSets.length" style="margin: 1rem 0;">
      </div>
      <div v-if="column.title == 'Nutzlose Variablen'">
        <UselessVar v-if="column.uselessVars" v-for="uselessVar in column.uselessVars" :key="uselessVar.symbol" :useless-var="uselessVar" :is-wrong="isHelpMode && column.hasErrors && isWrongVar(uselessVar)"></UselessVar>
        <hr v-if="column.uselessVars.length" style="margin: 1rem 0;">
      </div>
      <div class="rules">
      <Rule v-for="rule in column.rules" :is-wrong="column.isEditable ? isHelpMode && column.state == 'error' && isWrongRule(rule) : false" :key="rule" :rule="rule" :data-step="column.step" draggable="true" @dragstart="startDrag($event, rule)" @dragend="endDrag($event)"></Rule>
      </div>
      <button v-if="column.isEditable" class="add-button" @click="toggleModal" :disabled="column.state == 'locked'">
        +
      </button>
    </div>
  </div>
  <Modal :col-title="column.title" v-if="modalIsActive" :column="column"></Modal>
</template>

<script>
import DotsVerticalIcon from "vue-material-design-icons/DotsVertical.vue"
import CheckCircleIcon from "vue-material-design-icons/CheckCircle.vue"
import AlertIcon from "vue-material-design-icons/Alert.vue"
import LockIcon from "vue-material-design-icons/Lock.vue"
import ClockIcon from "vue-material-design-icons/Clock.vue"
import RestartIcon from "vue-material-design-icons/Restart.vue"
import Rule from "./Rule";
import {computed, inject, provide, ref, toRefs} from "vue";
import Modal from "./Modal";
import UnitRule from "./UnitRule";
import Dropdown from "./Dropdown";
import useRulesMap from "../composables/services/useRulesMap";
import UselessVar from "./UselessVar";
import useNonsolitaryTerminals from "../composables/useNonsolitaryTerminals";


export default {
  name: "Column",
  components: {
    Rule,
    UnitRule,
    UselessVar,
    Modal,
    DotsVerticalIcon,
    CheckCircleIcon,
    ClockIcon,
    RestartIcon,
    Dropdown,
    AlertIcon,
    LockIcon
  },
  props: {
    column: {
      type: Object,
      required: true
    },
    rules: {
      type: Array,
      required: true
    },
    terminals: {
      type: Array,
      required: true
    },
    nonterminals: {
      type: Array,
      required: true
    },
    startVariable: {
      type: String,
      required: true
    }
  },
  setup(props) {

    const modalIsActive = ref(false)
    const dropdownIsActive = ref(false)
    const allColumns = inject('columns')
    const isHelpMode = inject('isHelpMode');
    const wrongRules = ref([])
    const wrongUselessVars = ref([])
    const wrongUnitRules = ref([])

    const toggleModal = () => {
      modalIsActive.value = !modalIsActive.value
    }

    const toggleDropdown = () => {
      dropdownIsActive.value = !dropdownIsActive.value
    }

    const draggables = document.querySelectorAll('.draggable')
    const dropContainer = document.querySelectorAll('.column-content')

    const copyRule = (lhs, rhs) => {
      const ruleToBeCopied = {
        lhs,
        rhs
      }

      const ruleIndex = column.value.rules.findIndex(rule => {
        return rule.lhs === lhs && rule.rhs === rhs
      })

      const columnContainsRule = ruleIndex >= 0

      if((column.value.state == 'editing' || column.value.state == 'error') && !columnContainsRule) {
        column.value.rules.push(ruleToBeCopied)
        if(column.value.state == 'error') {
          column.value.state = 'editing'
        }
      }
    }

    const startDrag = (event, rule) => {
      const draggedElement = event.target
      draggedElement.classList.add('dragging')
      event.dataTransfer.dropEffect = 'copy'
      event.dataTransfer.effectAllowed = 'copy'
      event.dataTransfer.setData('rule', rule.lhs + '-' + rule.rhs)
    }

    const endDrag = (event) => {
      const draggedElement = event.target
      draggedElement.classList.remove('dragging')
    }

    const onDragover = (event) => {
      const dragging = document.querySelector('.dragging')
      const column = event.currentTarget
      console.log(column.dataset.step === dragging.dataset.step)
      if(column.dataset.step === dragging.dataset.step) {
        const columnRules = column.querySelector('.rules')
        const afterElement = getDragAfterElement(columnRules, event.clientY)

        if(afterElement == null) {
          columnRules.appendChild(dragging)
        } else {
          columnRules.insertBefore(dragging, afterElement)
        }
      } else {
        column.classList.add('draggedOver')
      }

    }

    const getDragAfterElement = (column, y) => {
      const draggableElements = [...column.querySelectorAll('.draggable:not(.dragging)')]

      return draggableElements.reduce((closest, child) => {
        const box = child.getBoundingClientRect()
        const offset = y - box.top - box.height / 2
        if(offset < 0 && offset > closest.offset) {
          return { offset: offset, element: child }
        } else {
          return closest
        }
      }, {offset: Number.NEGATIVE_INFINITY}).element
    }

    const onDragleave = (event) => {
      const column = event.currentTarget
      if(column.classList.contains('draggedOver')) {
        column.classList.remove('draggedOver')
      }

    }

    const onDrop = (event, step) => {
      const column = event.currentTarget
      column.classList.remove('draggedOver')
      const droppedRule= event.dataTransfer.getData('rule')
      const droppedRuleArray = droppedRule.split("-")
      copyRule(droppedRuleArray[0], droppedRuleArray[1], step)
    }

    const unlockNextStep = inject('unlockNextStep')

    const { column, rules, terminals, nonterminals, startVariable} = toRefs(props);

    const compareResult = (rules, expected) => {
      const isCorrect = rules.every(rule => expected.some(r => r.rhs === rule.rhs && r.lhs === rule.lhs))
      return isCorrect
    }

    const getWrongOnes = (rules, expected) => {
        let wrongOnes = rules.filter(rule => !expected.some(r => r.rhs === rule.rhs && r.lhs === rule.lhs))
        wrongRules.value = wrongOnes
    }

    const getWrongUselessVars = (vars, expected) => {
      let wrongOnes = vars.filter(v => !expected.some(expectedVar => expectedVar.symbol === v.symbol && expectedVar.isNotTerminating === v.isNotTerminating && expectedVar.isUnreachable === v.isUnreachable))
      wrongUselessVars.value = wrongOnes
    }

    const getWrongUnitSets = (unitRules, expectedUnitRules) => {
      const result = unitRules.filter(rule => {
        return expectedUnitRules.some(r => !isEqualUnitRule(rule, r))
      })
      wrongUnitRules.value = result
    }

    const isEqualUnitRule = (rule, comparedRule) => {
      let isEqualSym = rule.sym == comparedRule.sym
      let isEqualSet = rule.set.every(sym => comparedRule.set.includes(sym)) || (rule.set.length == 0 && comparedRule.set.length == 0);
      return isEqualSym && isEqualSet
    }

    const isEqualUselessVariable = (variable, comparedVariable) => {
      let isEqualSym = variable.symbol === comparedVariable.symbol
      let isEqualIsNotTerminating = variable.isNotTerminating === comparedVariable.isNotTerminating
      let isEqualIsUnreachable = variable.isUnreachable === comparedVariable.isUnreachable

      return isEqualSym && isEqualIsNotTerminating && isEqualIsUnreachable
    }

    const compareUnitRules = (unitRules, expectedUnitRules) => {
      const isEqualLength = expectedUnitRules.length === unitRules.length
      const isEqualRules = expectedUnitRules.every(rule => {
        const index = unitRules.findIndex(inputRule => inputRule.sym === rule.sym)
        return index >= 0 && isEqualUnitRule(rule, unitRules[index])
      })
      return isEqualLength && isEqualRules
    }

    const compareUselessVars = (uselessVars, expectedUselessVars) => {
      const isEqualLength = expectedUselessVars.length === uselessVars.length
      const isEqualRules = expectedUselessVars.every(variable => {
        const index = uselessVars.findIndex(inputVariable => inputVariable.symbol === variable.symbol)
        return index >= 0 && isEqualUselessVariable(variable, uselessVars[index])
      })

      return isEqualLength && isEqualRules
    }

    const filteredRules = (rules) => {
      const result = rules.filter(rule => !allColumns.value[column.value.step - 1].rules.some(r => rule.rhs == r.rhs && rule.lhs == r.lhs ))
      return result
    }

    const handleSuccess = () => {
      column.value.state = 'complete'
      column.value.isEditable = false
    }

    const handleFailure = () => {
      column.value.state = 'error'
    }

    const checkRulesForStepOne = (rules, expected, step) => {

      if(rules.length == expected.length && compareResult(rules, expected)) {
        handleSuccess()
        unlockNextStep(2)
      } else {
        getWrongOnes(rules, expected)
        handleFailure()
      }

    }

    const checkRulesForStepTwo = (rules, expected, step) => {
      if(rules.length == expected.length && compareResult(rules, expected) && compareUnitRules(column.value.unitRulesWithSets, column.value.expectedUnitRulesWithSets)) {
        handleSuccess()
        unlockNextStep(3)
      } else {
        getWrongOnes(rules, expected)
        getWrongUnitSets(column.value.unitRulesWithSets, column.value.expectedUnitRulesWithSets)
        handleFailure()
      }
    }

    const checkRulesForStepThree = (rules, expected, step) => {
      if(rules.length == expected.length && compareResult(rules, expected) && compareUselessVars(column.value.uselessVars, column.value.expectedUselessVars)) {
        handleSuccess()
        unlockNextStep(4)
      } else {
        getWrongUselessVars(column.value.uselessVars, column.value.expectedUselessVars)
        getWrongOnes(rules, expected)
        handleFailure()
      }
    }

    const checkRulesForStepFour = (rules, expected, step) => {

      /**
       * Checks if the right-hand side contains nonterminals
       * @param rhs
       * @returns {boolean}
       */
      const containsNonterminal = (rhs) => {
        return rhs.split("").some(sym => props.nonterminals.includes(sym))
      }
      /**
       * Checks if the right-hand side contains terminals
       * @param rhs
       * @returns {boolean}
       */
      const containsTerminal = (rhs) => {
        return rhs.split("").some(sym => props.terminals.includes(sym))
      }

      /**
       * Checks if a rule is in Chomsky normal form
       * @param rhs
       * @returns {boolean}
       */
      const isCNF = (rhs) => {
        const isSingleTerminal = rhs.length == 1 && containsTerminal(rhs)
        const isTwoNonterminals = rhs.length == 2 && rhs.split("").every(sym => containsNonterminal(rhs))

        return isSingleTerminal && isTwoNonterminals
      }

      /**
       * Checks if a righ-hand side contains nonsolitary terminals
       * @param rhs
       * @returns {boolean}
       */
      const containsNonsolitaryTerminals = (rhs) => {
        return !isCNF(rhs) && containsTerminal(rhs) && rhs.length > 1
      }

      const conatainsNonsolitaryRules = (rules) => {
        return rules.some(rule => containsNonsolitaryTerminals(rule.rhs))
      }

      const checkNewRules = (filteredRules) => {
        const modifiedRules = filteredRules.filter(rule => rule.rhs.length > 1)
        const newRules = filteredRules.filter(rule => rule.rhs.length == 1)
        const newRulesMap = useRulesMap(newRules)

        modifiedRules.forEach(rule => {
            let ruleToCheck = {}
            const rhsArr = rule.rhs.split("")

            let rhs = ""
            rhsArr.forEach(symbol => {
              if(newRulesMap.has(symbol)) {
                rhs += Array.from(newRulesMap.get(symbol))[0]
              } else {
                rhs += symbol
              }
            })

            ruleToCheck.lhs = rule.lhs
            ruleToCheck.rhs = rhs

            console.log(ruleToCheck)

            if(!allColumns.value[column.value.step - 1].rules
                .some(rule => rule.lhs == ruleToCheck.lhs && rule.rhs == ruleToCheck.rhs)) {
              wrongRules.value.push(rule)
            }

          })
      }

      checkNewRules(filteredRules(rules))

      if(rules.length == expected.length && !conatainsNonsolitaryRules(rules) && (compareResult(rules, expected) || wrongRules.value.length == 0)) {
        handleSuccess()
        unlockNextStep(5)
      } else {
        console.log(wrongRules.value)
        handleFailure()
      }
    }

    const checkRulesForStepFive = (rules, expected, step) => {
      const conatainsMoreThanTwoNonterminals = (rules) => {
        return rules.some(rule => rule.rhs.length > 2)
      }

      const checkNewRules = (filteredRules, rules) => {
        const newRules = filteredRules.filter(rule => !allColumns.value[column.value.step - 1].rules.some(r => r.lhs === rule.lhs))
        const modifiedRules = filteredRules.filter(rule => !newRules.some(r => r.rhs == rule.rhs && r.lhs == rule.lhs));
        const newRulesMap = useRulesMap(newRules)

        const resolveModifiedRules = () => {

          const result = []
          modifiedRules.forEach(rule => {
                let resolvedRuleLHS = rule.lhs
                let resolvedRuleRHS = rule.rhs
                let resolvedRuleRHSArr = resolvedRuleRHS.split("")
                let hasNewSymbol = resolvedRuleRHSArr.some(symbol => newRulesMap.has(symbol))

                while(hasNewSymbol) {
                  resolvedRuleRHSArr = resolvedRuleRHSArr.map(symbol => {
                    if(newRulesMap.has(symbol)) {
                      return Array.from(newRulesMap.get(symbol))[0]
                    } else {
                      return symbol
                    }
                  })

                  resolvedRuleRHS = resolvedRuleRHSArr.join("")
                  resolvedRuleRHSArr = resolvedRuleRHS.split("")
                  hasNewSymbol = resolvedRuleRHSArr.some(symbol => newRulesMap.has(symbol))
                }

                result.push({
                  lhs: resolvedRuleLHS,
                  rhs: resolvedRuleRHS
                })
              })

            return result
        }

        const resolvedRules = resolveModifiedRules()

        const checkResolvedRules = () => {
          let isCorrect = false

          resolvedRules.forEach(rule => {
            if(allColumns.value[4].rules.some(r => {
              return r.rhs === rule.rhs && r.lhs === rule.lhs
            })) {
              isCorrect = true
            } else {
              isCorrect = false
              return
            }
          })

          return isCorrect
        }
        const checkOtherRules = () => {
          const resultArr = rules.filter(rule => !filteredRules.some(r => rule.rhs == r.rhs && rule.lhs == r.lhs))
          const isCorrect = resultArr.every(rule => allColumns.value[4].rules.some(r => rule.rhs == r.rhs && rule.lhs == r.lhs))
          return isCorrect
        }

        const resolvedRulesAreCorrect = checkResolvedRules()
        const otherRulesAreCorrect = checkOtherRules()

        return resolvedRulesAreCorrect && otherRulesAreCorrect

      }

      if(rules.length == expected.length && !conatainsMoreThanTwoNonterminals(rules) && (compareResult(rules, expected) || checkNewRules(filteredRules(rules), rules))) {
        handleSuccess()
      } else {
        handleFailure()
      }
    }

    const checkResult = (column) => {
      switch(column.step) {
        case 1:
          checkRulesForStepOne(column.rules, column.expected, column.step)
            toggleDropdown()
          break
        case 2:
          checkRulesForStepTwo(column.rules, column.expected, column.step)
            toggleDropdown()
          break
        case 3:
          checkRulesForStepThree(column.rules, column.expected, column.step)
            toggleDropdown()
          break
        case 4:
          checkRulesForStepFour(column.rules, column.expected, column.step)
            toggleDropdown()
          break
        case 5:
          checkRulesForStepFive(column.rules, column.expected, column.step)
            toggleDropdown()
          break
      }
    }

    const isWrongRule = (rule) => {
      return wrongRules.value.some(r => r.rhs == rule.rhs && r.lhs == rule.lhs)
    }

    const isWrongVar = (variable) => {
      return wrongUselessVars.value.some(v => v.symbol == variable.symbol && v.isNotTerminating == variable.isNotTerminating && v.isUnreachable == variable.isUnreachable)
    }

    const isWrongUnitRule = (unitRule) => {
      return wrongUnitRules.value.some(rule => isEqualUnitRule(rule, unitRule))
    }

    provide('col', column)
    provide('toggleModal', toggleModal)

    return {
      modalIsActive,
      toggleModal,
      dropdownIsActive,
      toggleDropdown,
      isHelpMode,
      isWrongRule,
      isWrongVar,
      isWrongUnitRule,
      checkResult,
      onDrop,
      onDragover,
      onDragleave,
      startDrag,
      endDrag
    }
  }
}
</script>

<style scoped>

</style>